pub type Selector = [u8; 4];

// Re-export common ethereum datatypes with more specific names

/// A transaction Hash
pub use ethereum_types::H256 as TxHash;

pub use ethereum_types::{Address, Bloom, H160, H256, U128, U256, U64};

mod transaction;
pub use transaction::{Transaction, TransactionReceipt, TransactionRequest};

mod bytes;
pub use bytes::Bytes;

mod block;
pub use block::{Block, BlockId, BlockNumber};

mod log;
pub use log::{Filter, Log, ValueOrArray};

mod ens;
pub use ens::NameOrAddress;
